# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'Base64sha256Result',
    'AwaitableBase64sha256Result',
    'base64sha256',
    'base64sha256_output',
]

@pulumi.output_type
class Base64sha256Result:
    def __init__(__self__, result=None):
        if result and not isinstance(result, str):
            raise TypeError("Expected argument 'result' to be a str")
        pulumi.set(__self__, "result", result)

    @property
    @pulumi.getter
    def result(self) -> str:
        return pulumi.get(self, "result")


class AwaitableBase64sha256Result(Base64sha256Result):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return Base64sha256Result(
            result=self.result)


def base64sha256(input: Optional[str] = None,
                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableBase64sha256Result:
    """
    Returns a base64-encoded representation of raw SHA-256 sum of the given string.
    This is not equivalent of base64encode(sha256(string)) since sha256() returns hexadecimal representation.
    """
    __args__ = dict()
    __args__['input'] = input
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('std:index:base64sha256', __args__, opts=opts, typ=Base64sha256Result).value

    return AwaitableBase64sha256Result(
        result=__ret__.result)


@_utilities.lift_output_func(base64sha256)
def base64sha256_output(input: Optional[pulumi.Input[str]] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[Base64sha256Result]:
    """
    Returns a base64-encoded representation of raw SHA-256 sum of the given string.
    This is not equivalent of base64encode(sha256(string)) since sha256() returns hexadecimal representation.
    """
    ...
