# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'BcryptResult',
    'AwaitableBcryptResult',
    'bcrypt',
    'bcrypt_output',
]

@pulumi.output_type
class BcryptResult:
    def __init__(__self__, result=None):
        if result and not isinstance(result, str):
            raise TypeError("Expected argument 'result' to be a str")
        pulumi.set(__self__, "result", result)

    @property
    @pulumi.getter
    def result(self) -> str:
        return pulumi.get(self, "result")


class AwaitableBcryptResult(BcryptResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return BcryptResult(
            result=self.result)


def bcrypt(cost: Optional[int] = None,
           input: Optional[str] = None,
           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableBcryptResult:
    """
    Returns the Blowfish encrypted hash of the string at the given cost.
    A default cost of 10 will be used if not provided.
    """
    __args__ = dict()
    __args__['cost'] = cost
    __args__['input'] = input
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('std:index:bcrypt', __args__, opts=opts, typ=BcryptResult).value

    return AwaitableBcryptResult(
        result=__ret__.result)


@_utilities.lift_output_func(bcrypt)
def bcrypt_output(cost: Optional[pulumi.Input[Optional[int]]] = None,
                  input: Optional[pulumi.Input[str]] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[BcryptResult]:
    """
    Returns the Blowfish encrypted hash of the string at the given cost.
    A default cost of 10 will be used if not provided.
    """
    ...
